diff --git a/packages/code-generator/src/utils/nodeToJSX.ts b/packages/code-generator/src/utils/nodeToJSX.ts
index 237221346..6f91b8d81 100644
--- a/packages/code-generator/src/utils/nodeToJSX.ts
+++ b/packages/code-generator/src/utils/nodeToJSX.ts
@@ -1,220 +1,154 @@
+import _ from 'lodash';
+import { NodeSchema, isNodeSchema, NodeDataType, CompositeValue } from '@ali/lowcode-types';
+
 import {
-  ChildNodeType,
-  IComponentNodeItem,
-  IJSExpression,
-  ChildNodeItem,
+  IScope,
   CodeGeneratorError,
   PIECE_TYPE,
   CodePiece,
-  HandlerSet,
-  ExtGeneratorPlugin,
-  IJSSlot,
-  INodeGeneratorConfig,
-  INodeGeneratorContext,
   NodeGenerator,
+  NodeGeneratorConfig,
+  NodePlugin,
+  AttrData,
 } from '../types';
+
 import { generateCompositeType } from './compositeType';
-import { generateExpression, isJsExpression } from './jsExpression';
-import { isJsSlot } from './jsSlot';
+import { executeFunctionStack } from './aopHelper';
 
-// tslint:disable-next-line: no-empty
-const noop = () => [];
-
-const handleChildrenDefaultOptions = {
-  rerun: false,
-};
-
-export function handleSubNodes<T>(
-  children: ChildNodeType,
-  handlers: HandlerSet<T>,
-  options?: {
-    rerun?: boolean;
-  },
-): T[] {
-  const opt = {
-    ...handleChildrenDefaultOptions,
-    ...(options || {}),
-  };
-
-  if (Array.isArray(children)) {
-    const list: ChildNodeItem[] = children as ChildNodeItem[];
-    return list.map((child) => handleSubNodes(child, handlers, opt)).reduce((p, c) => p.concat(c), []);
-  } else if (typeof children === 'string') {
-    const handler = handlers.string || handlers.common || noop;
-    return handler(children as string);
-  } else if (isJsExpression(children)) {
-    const handler = handlers.expression || handlers.common || noop;
-    return handler(children as IJSExpression);
-  } else {
-    const handler = handlers.node || handlers.common || noop;
-    let curRes = handler(children as IComponentNodeItem);
-    if (opt.rerun && children.children) {
-      const childRes = handleSubNodes(children.children, handlers, opt);
-      curRes = curRes.concat(childRes || []);
-    }
-    if (children.props) {
-      Object.keys(children.props)
-        .filter((propName) => isJsSlot(children.props[propName]))
-        .forEach((propName) => {
-          const soltVals = (children.props[propName] as IJSSlot).value;
-          (soltVals || []).forEach((soltVal) => {
-            const childRes = handleSubNodes(soltVal, handlers, opt);
-            curRes = curRes.concat(childRes || []);
-          });
-        });
-    }
-    return curRes;
+function mergeNodeGeneratorConfig(cfg1: NodeGeneratorConfig, cfg2: NodeGeneratorConfig = {}): NodeGeneratorConfig {
+  const resCfg: NodeGeneratorConfig = {};
+  if (cfg1.handlers || cfg2.handlers) {
+    resCfg.handlers = {
+      ...(cfg1.handlers || {}),
+      ...(cfg2.handlers || {}),
+    };
   }
+
+  if (cfg1.tagMapping || cfg2.tagMapping) {
+    resCfg.tagMapping = cfg2.tagMapping || cfg1.tagMapping;
+  }
+
+  if (cfg1.attrPlugins || cfg2.attrPlugins) {
+    resCfg.attrPlugins = [];
+    resCfg.attrPlugins.push(...(cfg2.attrPlugins || []));
+    resCfg.attrPlugins.push(...(cfg1.attrPlugins || []));
+  }
+
+  if (cfg1.nodePlugins || cfg2.nodePlugins) {
+    resCfg.nodePlugins = [];
+    resCfg.nodePlugins.push(...(cfg2.nodePlugins || []));
+    resCfg.nodePlugins.push(...(cfg1.nodePlugins || []));
+  }
+
+  return resCfg;
 }
 
-export function handleChildren<T>(
-  ctx: INodeGeneratorContext,
-  children: ChildNodeType,
-  handlers: HandlerSet<T>,
-  options?: {
-    rerun?: boolean;
-  },
-): T[] {
-  const opt = {
-    ...handleChildrenDefaultOptions,
-    ...(options || {}),
-  };
-
-  if (Array.isArray(children)) {
-    const list: ChildNodeItem[] = children as ChildNodeItem[];
-    return list.map((child) => handleChildren(ctx, child, handlers, opt)).reduce((p, c) => p.concat(c), []);
-  } else if (typeof children === 'string') {
-    const handler = handlers.string || handlers.common || noop;
-    return handler(children as string);
-  } else if (isJsExpression(children)) {
-    const handler = handlers.expression || handlers.common || noop;
-    return handler(children as IJSExpression);
-  } else {
-    const handler = handlers.node || handlers.common || noop;
-    let curRes = handler(children as IComponentNodeItem);
-    if (opt.rerun && children.children) {
-      const childRes = handleChildren(ctx, children.children, handlers, opt);
-      curRes = curRes.concat(childRes || []);
-    }
-    return curRes;
-  }
-}
-
-export function generateAttr(ctx: INodeGeneratorContext, attrName: string, attrValue: any): CodePiece[] {
-  if (attrName === 'initValue') {
-    return [];
-  }
-  const valueStr = generateCompositeType(attrValue, {
-    containerHandlers: {
-      default: (v) => `{${v}}`,
-      string: (v) => `"${v}"`,
-    },
-    nodeGenerator: ctx.generator,
+function generateAttrValue(
+  attrData: { attrName: string; attrValue: CompositeValue },
+  scope: IScope,
+  config?: NodeGeneratorConfig,
+): CodePiece[] {
+  const valueStr = generateCompositeType(attrData.attrValue, scope, {
+    handlers: config?.handlers,
+    nodeGenerator: config?.self,
   });
   return [
     {
-      value: `${attrName}=${valueStr}`,
       type: PIECE_TYPE.ATTR,
+      name: attrData.attrName,
+      value: valueStr,
     },
   ];
 }
 
-export function generateAttrs(ctx: INodeGeneratorContext, nodeItem: IComponentNodeItem): CodePiece[] {
-  const { props } = nodeItem;
-  let pieces: CodePiece[] = [];
+function generateAttr(
+  attrName: string,
+  attrValue: CompositeValue,
+  scope: IScope,
+  config?: NodeGeneratorConfig,
+): CodePiece[] {
+  let pieces: CodePiece[];
+  if (config?.attrPlugins) {
+    pieces = executeFunctionStack<AttrData, CodePiece[], NodeGeneratorConfig>(
+      { attrName, attrValue },
+      scope,
+      config.attrPlugins,
+      generateAttrValue,
+      config,
+    );
+  } else {
+    pieces = generateAttrValue({ attrName, attrValue }, scope, config);
+  }
 
-  Object.keys(props).forEach(
-    (propName: string) => (pieces = pieces.concat(generateAttr(ctx, propName, props[propName]))),
-  );
+  pieces = pieces.map((p) => {
+    // FIXME: 在经过 generateCompositeType 处理过之后，其实已经无法通过传入值的类型判断传出值是否为纯字面值字符串了（可能包裹了加工函数之类的）
+    //        因此这个处理最好的方式是对传出值做语法分析，判断以哪种模版产出 Attr 值
+    let newValue: string;
+    if (p.value && p.value[0] === "'" && p.value[p.value.length - 1] === "'") {
+      newValue = `"${p.value.substring(1, p.value.length - 1)}"`;
+    } else {
+      newValue = `{${p.value}}`;
+    }
+
+    return {
+      value: `${p.name}=${newValue}`,
+      type: PIECE_TYPE.ATTR,
+    };
+  });
 
   return pieces;
 }
 
-function mapNodeName(src: string, mapping: Record<string, string>): string {
-  if (mapping[src]) {
-    return mapping[src];
+function generateAttrs(nodeItem: NodeSchema, scope: IScope, config?: NodeGeneratorConfig): CodePiece[] {
+  const { props } = nodeItem;
+
+  let pieces: CodePiece[] = [];
+
+  if (props) {
+    if (!Array.isArray(props)) {
+      Object.keys(props).forEach((propName: string) => {
+        pieces = pieces.concat(generateAttr(propName, props[propName], scope, config));
+      });
+    } else {
+      props.forEach((prop) => {
+        if (prop.name && !prop.spread) {
+          pieces = pieces.concat(generateAttr(prop.name, prop.value, scope, config));
+        }
+
+        // TODO: 处理 spread 场景（<Xxx {...(something)}/>)
+        // 这种在 schema 里面怎么描述
+      });
+    }
   }
-  return src;
+
+  return pieces;
 }
 
-export function generateBasicNode(
-  ctx: INodeGeneratorContext,
-  nodeItem: IComponentNodeItem,
-  mapping: Record<string, string>,
-): CodePiece[] {
+function generateBasicNode(nodeItem: NodeSchema, scope: IScope, config?: NodeGeneratorConfig): CodePiece[] {
   const pieces: CodePiece[] = [];
+  const tagName = (config?.tagMapping || _.identity)(nodeItem.componentName);
+
   pieces.push({
-    value: mapNodeName(nodeItem.componentName, mapping),
+    value: tagName || '', // FIXME: type detection error
     type: PIECE_TYPE.TAG,
   });
 
   return pieces;
 }
 
-// TODO: 生成文档
-// 为包裹的代码片段生成子上下文，集成父级上下文，并传入子级上下文新增内容。（如果存在多级上下文怎么处理？）
-// 创建新的上下文，并从作用域中取对应同名变量塞到作用域里面？
-// export function createSubContext() {}
+function generateSimpleNode(nodeItem: NodeSchema, scope: IScope, config?: NodeGeneratorConfig): CodePiece[] {
+  const basicParts = generateBasicNode(nodeItem, scope, config) || [];
+  const attrParts = generateAttrs(nodeItem, scope, config) || [];
 
-/**
- * JSX 生成逻辑插件。在 React 代码模式下生成 loop 与 condition 相关的逻辑代码
- *
- * @export
- * @param {IComponentNodeItem} nodeItem 当前 UI 节点
- * @returns {CodePiece[]} 实现功能的相关代码片段
- */
-export function generateReactCtrlLine(ctx: INodeGeneratorContext, nodeItem: IComponentNodeItem): CodePiece[] {
-  const pieces: CodePiece[] = [];
-
-  if (nodeItem.loop) {
-    const args: [string, string] = nodeItem.loopArgs || ['item', 'index'];
-    const loopData = generateCompositeType(nodeItem.loop, {
-      nodeGenerator: ctx.generator,
-    });
-    pieces.unshift({
-      value: `(${loopData}).map((${args[0]}, ${args[1]}) => (`,
-      type: PIECE_TYPE.BEFORE,
-    });
-    pieces.push({
-      value: '))',
-      type: PIECE_TYPE.AFTER,
-    });
-  }
-
-  if (nodeItem.condition) {
-    const value = generateCompositeType(nodeItem.condition, {
-      nodeGenerator: ctx.generator,
-    });
-
-    pieces.unshift({
-      value: `(${value}) && (`,
-      type: PIECE_TYPE.BEFORE,
-    });
-    pieces.push({
-      value: ')',
-      type: PIECE_TYPE.AFTER,
-    });
-  }
-
-  if (nodeItem.condition || nodeItem.loop) {
-    pieces.unshift({
-      value: '{',
-      type: PIECE_TYPE.BEFORE,
-    });
-    pieces.push({
-      value: '}',
-      type: PIECE_TYPE.AFTER,
-    });
-  }
-
-  return pieces;
+  return [...basicParts, ...attrParts];
 }
 
-export function linkPieces(pieces: CodePiece[]): string {
-  if (pieces.filter((p) => p.type === PIECE_TYPE.TAG).length !== 1) {
+function linkPieces(pieces: CodePiece[]): string {
+  const tagsPieces = pieces.filter((p) => p.type === PIECE_TYPE.TAG);
+  if (tagsPieces.length !== 1) {
     throw new CodeGeneratorError('One node only need one tag define');
   }
-  const tagName = pieces.filter((p) => p.type === PIECE_TYPE.TAG)[0].value;
+  const tagName = tagsPieces[0].value;
 
   const beforeParts = pieces
     .filter((p) => p.type === PIECE_TYPE.BEFORE)
@@ -245,53 +179,173 @@ export function linkPieces(pieces: CodePiece[]): string {
   return `${beforeParts}<${tagName}${attrsParts} />${afterParts}`;
 }
 
-export function createNodeGenerator(
-  handlers: HandlerSet<string>,
-  plugins: ExtGeneratorPlugin[],
-  cfg?: INodeGeneratorConfig,
-): NodeGenerator {
-  let nodeTypeMapping: Record<string, string> = {};
-  if (cfg && cfg.nodeTypeMapping) {
-    nodeTypeMapping = cfg.nodeTypeMapping;
+function generateNodeSchema(nodeItem: NodeSchema, scope: IScope, config?: NodeGeneratorConfig): string {
+  const pieces: CodePiece[] = [];
+  if (config?.nodePlugins) {
+    const res = executeFunctionStack<NodeSchema, CodePiece[], NodeGeneratorConfig>(
+      nodeItem,
+      scope,
+      config.nodePlugins,
+      generateSimpleNode,
+      config,
+    );
+    pieces.push(...res);
+  } else {
+    pieces.push(...generateSimpleNode(nodeItem, scope, config));
   }
 
-  const generateNode = (nodeItem: IComponentNodeItem): string => {
-    let pieces: CodePiece[] = [];
-    const ctx: INodeGeneratorContext = {
-      generator: generateNode,
-    };
+  if (nodeItem.children && config?.self) {
+    const childrenStr = config.self(nodeItem.children, scope);
 
-    plugins.forEach((p) => {
-      pieces = pieces.concat(p(ctx, nodeItem));
+    pieces.push({
+      type: PIECE_TYPE.CHILDREN,
+      value: childrenStr,
     });
-    pieces = pieces.concat(generateBasicNode(ctx, nodeItem, nodeTypeMapping));
-    pieces = pieces.concat(generateAttrs(ctx, nodeItem));
-    if (nodeItem.children && (nodeItem.children as unknown[]).length > 0) {
-      pieces = pieces.concat(
-        handleChildren<string>(ctx, nodeItem.children, handlers).map((l) => ({
-          type: PIECE_TYPE.CHILDREN,
-          value: l,
-        })),
-      );
+  }
+
+  return linkPieces(pieces);
+}
+
+// TODO: 生成文档
+// 为包裹的代码片段生成子上下文，集成父级上下文，并传入子级上下文新增内容。（如果存在多级上下文怎么处理？）
+// 创建新的上下文，并从作用域中取对应同名变量塞到作用域里面？
+// export function createSubContext() {}
+
+/**
+ * JSX 生成逻辑插件。在 React 代码模式下生成 loop 相关的逻辑代码
+ * @type NodePlugin Extended
+ *
+ * @export
+ * @param {NodeSchema} nodeItem 当前 UI 节点
+ * @returns {CodePiece[]} 实现功能的相关代码片段
+ */
+export function generateReactLoopCtrl(
+  nodeItem: NodeSchema,
+  scope: IScope,
+  config?: NodeGeneratorConfig,
+  next?: NodePlugin,
+): CodePiece[] {
+  const pieces: CodePiece[] = next ? next(nodeItem, scope, config) : [];
+
+  if (nodeItem.loop) {
+    const loopItemName = nodeItem.loopArgs?.[0] || 'item';
+    const loopIndexName = nodeItem.loopArgs?.[1] || 'index';
+
+    const loopDataExpr = generateCompositeType(nodeItem.loop, scope, {
+      handlers: config?.handlers,
+    });
+
+    pieces.unshift({
+      value: `${loopDataExpr}.map((${loopItemName}, ${loopIndexName}) => (`,
+      type: PIECE_TYPE.BEFORE,
+    });
+
+    pieces.push({
+      value: '))',
+      type: PIECE_TYPE.AFTER,
+    });
+  }
+
+  return pieces;
+}
+
+/**
+ * JSX 生成逻辑插件。在 React 代码模式下生成 condition 相关的逻辑代码
+ * @type NodePlugin
+ *
+ * @export
+ * @param {NodeSchema} nodeItem 当前 UI 节点
+ * @returns {CodePiece[]} 实现功能的相关代码片段
+ */
+export function generateConditionReactCtrl(
+  nodeItem: NodeSchema,
+  scope: IScope,
+  config?: NodeGeneratorConfig,
+  next?: NodePlugin,
+): CodePiece[] {
+  const pieces: CodePiece[] = next ? next(nodeItem, scope, config) : [];
+
+  if (nodeItem.condition) {
+    const value = generateCompositeType(nodeItem.condition, scope, {
+      handlers: config?.handlers,
+    });
+
+    pieces.unshift({
+      value: `(${value}) && (`,
+      type: PIECE_TYPE.BEFORE,
+    });
+
+    pieces.push({
+      value: ')',
+      type: PIECE_TYPE.AFTER,
+    });
+  }
+
+  return pieces;
+}
+
+/**
+ * JSX 生成逻辑插件。在 React 代码模式下，如果 Node 生成结果是一个表达式，则对其进行 { Expression } 包装
+ * @type NodePlugin
+ *
+ * @export
+ * @param {NodeSchema} nodeItem 当前 UI 节点
+ * @returns {CodePiece[]} 实现功能的相关代码片段
+ */
+export function generateReactExprInJS(
+  nodeItem: NodeSchema,
+  scope: IScope,
+  config?: NodeGeneratorConfig,
+  next?: NodePlugin,
+): CodePiece[] {
+  const pieces: CodePiece[] = next ? next(nodeItem, scope, config) : [];
+
+  if (nodeItem.condition || nodeItem.loop) {
+    pieces.unshift({
+      value: '{',
+      type: PIECE_TYPE.BEFORE,
+    });
+
+    pieces.push({
+      value: '}',
+      type: PIECE_TYPE.AFTER,
+    });
+  }
+
+  return pieces;
+}
+
+const handleChildren = (v: string[]) => v.join('');
+
+export function createNodeGenerator(cfg: NodeGeneratorConfig = {}): NodeGenerator<string> {
+  const generateNode = (nodeItem: NodeDataType, scope: IScope): string => {
+    if (_.isArray(nodeItem)) {
+      const resList = nodeItem.map((n) => generateNode(n, scope));
+      return handleChildren(resList);
     }
 
-    return linkPieces(pieces);
-  };
+    if (isNodeSchema(nodeItem)) {
+      return generateNodeSchema(nodeItem, scope, {
+        ...cfg,
+        self: generateNode,
+      });
+    }
 
-  handlers.node = (input: IComponentNodeItem) => [generateNode(input)];
+    return generateCompositeType(nodeItem, scope, {
+      handlers: cfg.handlers,
+      nodeGenerator: generateNode,
+    });
+  };
 
   return generateNode;
 }
 
-export const generateString = (input: string) => [input];
+const defaultReactGeneratorConfig: NodeGeneratorConfig = {
+  nodePlugins: [generateReactExprInJS, generateConditionReactCtrl, generateReactLoopCtrl],
+};
 
-export function createReactNodeGenerator(cfg?: INodeGeneratorConfig): NodeGenerator {
-  return createNodeGenerator(
-    {
-      string: generateString,
-      expression: (input) => [generateExpression(input)],
-    },
-    [generateReactCtrlLine],
-    cfg,
-  );
+export function createReactNodeGenerator(cfg?: NodeGeneratorConfig): NodeGenerator<string> {
+  const newCfg = mergeNodeGeneratorConfig(defaultReactGeneratorConfig, cfg);
+
+  return createNodeGenerator(newCfg);
 }
diff --git a/packages/code-generator/src/utils/resultHelper.ts b/packages/code-generator/src/utils/resultHelper.ts
new file mode 100644
index 000000000..35b9fe7b0
--- /dev/null
+++ b/packages/code-generator/src/utils/resultHelper.ts
@@ -0,0 +1,35 @@
+import { ResultFile, ResultDir } from '@ali/lowcode-types';
+
+import { CodeGeneratorError } from '../types/error';
+
+export function createResultFile(name: string, ext = 'jsx', content = ''): ResultFile {
+  return {
+    name,
+    ext,
+    content,
+  };
+}
+
+export function createResultDir(name: string): ResultDir {
+  return {
+    name,
+    dirs: [],
+    files: [],
+  };
+}
+
+export function addDirectory(target: ResultDir, dir: ResultDir): void {
+  if (target.dirs.findIndex((d) => d.name === dir.name) < 0) {
+    target.dirs.push(dir);
+  } else {
+    throw new CodeGeneratorError(`Adding same directory to one directory: ${dir.name} -> ${target.name}`);
+  }
+}
+
+export function addFile(target: ResultDir, file: ResultFile): void {
+  if (target.files.findIndex((f) => f.name === file.name && f.ext === file.ext) < 0) {
+    target.files.push(file);
+  } else {
+    throw new CodeGeneratorError(`Adding same file to one directory: ${file.name} -> ${target.name}`);
+  }
+}
diff --git a/packages/code-generator/src/utils/schema.ts b/packages/code-generator/src/utils/schema.ts
new file mode 100644
index 000000000..527b22f60
--- /dev/null
+++ b/packages/code-generator/src/utils/schema.ts
@@ -0,0 +1,87 @@
+import {
+  JSSlot,
+  JSExpression,
+  NodeData,
+  NodeSchema,
+  PropsMap,
+  isJSExpression,
+  isJSSlot,
+  isDOMText,
+  ContainerSchema,
+  NpmInfo,
+} from '@ali/lowcode-types';
+
+export function isContainerSchema(x: any): x is ContainerSchema {
+  return typeof x === 'object' && x && typeof x.componentName === 'string' && typeof x.fileName === 'string';
+}
+
+export function isNpmInfo(x: any): x is NpmInfo {
+  return typeof x === 'object' && x && typeof x.package === 'string';
+}
+
+// tslint:disable-next-line: no-empty
+const noop = () => undefined;
+
+const handleChildrenDefaultOptions = {
+  rerun: false,
+};
+
+export function handleSubNodes<T>(
+  children: unknown,
+  handlers: {
+    string?: (i: string) => T;
+    expression?: (i: JSExpression) => T;
+    node?: (i: NodeSchema) => T;
+  },
+  options?: {
+    rerun?: boolean;
+  },
+): T[] {
+  const opt = {
+    ...handleChildrenDefaultOptions,
+    ...(options || {}),
+  };
+
+  if (Array.isArray(children)) {
+    const list: NodeData[] = children as NodeData[];
+    return list.map(
+      (child) => handleSubNodes(child, handlers, opt)
+    ).reduce((p, c) => p.concat(c), []);
+  }
+
+  let result: T | undefined;
+  const childrenRes: T[] = [];
+  if (isDOMText(children)) {
+    const handler = handlers.string || noop;
+    result = handler(children as string);
+  } else if (isJSExpression(children)) {
+    const handler = handlers.expression || noop;
+    result = handler(children as JSExpression);
+  } else {
+    const handler = handlers.node || noop;
+    const child = children as NodeSchema;
+    result = handler(child);
+
+    if (opt.rerun && child.children) {
+      const childRes = handleSubNodes(child.children, handlers, opt);
+      childrenRes.push(...childRes);
+    }
+    if (child.props) {
+      // FIXME: currently only support PropsMap
+      const childProps = child.props as PropsMap;
+      Object.keys(childProps)
+        .filter((propName) => isJSSlot(childProps[propName]))
+        .forEach((propName) => {
+          const soltVals = (childProps[propName] as JSSlot).value;
+          const childRes = handleSubNodes(soltVals, handlers, opt);
+          childrenRes.push(...childRes);
+        });
+    }
+  }
+
+  if (result !== undefined) {
+    childrenRes.unshift(result);
+  }
+
+  return childrenRes;
+}
diff --git a/packages/code-generator/src/utils/templateHelper.ts b/packages/code-generator/src/utils/templateHelper.ts
index f1692ad67..90b66c50f 100644
--- a/packages/code-generator/src/utils/templateHelper.ts
+++ b/packages/code-generator/src/utils/templateHelper.ts
@@ -1,25 +1,25 @@
-import { IResultFile, IResultDir } from '../types';
-import ResultDir from '../model/ResultDir';
+import { ResultDir, ResultFile } from '@ali/lowcode-types';
+import { createResultDir, addDirectory, addFile } from '../utils/resultHelper';
 
-type FuncFileGenerator = () => [string[], IResultFile];
+type FuncFileGenerator = () => [string[], ResultFile];
 
-export function insertFile(root: IResultDir, path: string[], file: IResultFile) {
-  let current: IResultDir = root;
-  path.forEach(pathNode => {
-    const dir = current.dirs.find(d => d.name === pathNode);
+export function insertFile(root: ResultDir, path: string[], file: ResultFile) {
+  let current: ResultDir = root;
+  path.forEach((pathNode) => {
+    const dir = current.dirs.find((d) => d.name === pathNode);
     if (dir) {
       current = dir;
     } else {
-      const newDir = new ResultDir(pathNode);
-      current.addDirectory(newDir);
+      const newDir = createResultDir(pathNode);
+      addDirectory(current, newDir);
       current = newDir;
     }
   });
 
-  current.addFile(file);
+  addFile(current, file);
 }
 
-export function runFileGenerator(root: IResultDir, fun: FuncFileGenerator) {
+export function runFileGenerator(root: ResultDir, fun: FuncFileGenerator) {
   const [path, file] = fun();
   insertFile(root, path, file);
 }
diff --git a/packages/code-generator/src/utils/version.ts b/packages/code-generator/src/utils/version.ts
new file mode 100644
index 000000000..4f5e607e8
--- /dev/null
+++ b/packages/code-generator/src/utils/version.ts
@@ -0,0 +1,29 @@
+import semver from 'semver';
+
+export function calcCompatibleVersion(v1: string | undefined | null, v2: string | undefined | null): string {
+  if (!v1 && !v2) {
+    return '*';
+  }
+
+  if (!v1 || v1 === '*') {
+    return v2 || '*';
+  }
+
+  if (!v2 || v2 === '*') {
+    return v1;
+  }
+
+  if (v1 === v2) {
+    return v1;
+  }
+
+  if (!semver.intersects(v1, v2, { loose: true })) {
+    throw new Error(`no compatible versions for "${v1}" and "${v2}"`);
+  }
+
+  if (semver.subset(v1, v2, { loose: true })) {
+    return v1;
+  }
+
+  return v2;
+}
diff --git a/packages/code-generator/test-cases/.gitignore b/packages/code-generator/test-cases/.gitignore
new file mode 100644
index 000000000..b36969646
--- /dev/null
+++ b/packages/code-generator/test-cases/.gitignore
@@ -0,0 +1 @@
+actual/
diff --git a/packages/code-generator/test-cases/rax-app/demo1/expected/demo-project/.editorconfig b/packages/code-generator/test-cases/rax-app/demo1/expected/demo-project/.editorconfig
new file mode 100644
index 000000000..5760be583
--- /dev/null
+++ b/packages/code-generator/test-cases/rax-app/demo1/expected/demo-project/.editorconfig
@@ -0,0 +1,12 @@
+# http://editorconfig.org
+root = true
+
+[*]
+indent_style = space
+indent_size = 2
+charset = utf-8
+trim_trailing_whitespace = true
+insert_final_newline = true
+
+[*.md]
+trim_trailing_whitespace = false
diff --git a/packages/code-generator/test-cases/rax-app/demo1/expected/demo-project/.eslintignore b/packages/code-generator/test-cases/rax-app/demo1/expected/demo-project/.eslintignore
new file mode 100644
index 000000000..3b437e614
--- /dev/null
+++ b/packages/code-generator/test-cases/rax-app/demo1/expected/demo-project/.eslintignore
@@ -0,0 +1,11 @@
+# 忽略目录
+build/
+tests/
+demo/
+
+# node 覆盖率文件
+coverage/
+
+# 忽略文件
+**/*-min.js
+**/*.min.js
diff --git a/packages/code-generator/test-cases/rax-app/demo1/expected/demo-project/.eslintrc.js b/packages/code-generator/test-cases/rax-app/demo1/expected/demo-project/.eslintrc.js
new file mode 100644
index 000000000..e2a7c5b54
--- /dev/null
+++ b/packages/code-generator/test-cases/rax-app/demo1/expected/demo-project/.eslintrc.js
@@ -0,0 +1,3 @@
+module.exports = {
+  extends: ['rax'],
+};
diff --git a/packages/code-generator/test-cases/rax-app/demo1/expected/demo-project/.gitignore b/packages/code-generator/test-cases/rax-app/demo1/expected/demo-project/.gitignore
new file mode 100644
index 000000000..50a53dace
--- /dev/null
+++ b/packages/code-generator/test-cases/rax-app/demo1/expected/demo-project/.gitignore
@@ -0,0 +1,17 @@
+# See https://help.github.com/articles/ignoring-files/ for more about ignoring files.
+
+*~
+*.swp
+*.log
+
+.DS_Store
+.idea/
+.temp/
+
+build/
+dist/
+lib/
+coverage/
+node_modules/
+
+template.yml
diff --git a/packages/code-generator/test-cases/rax-app/demo1/expected/demo-project/src/app.js b/packages/code-generator/test-cases/rax-app/demo1/expected/demo-project/src/app.js
new file mode 100644
index 000000000..bc474c6e3
--- /dev/null
+++ b/packages/code-generator/test-cases/rax-app/demo1/expected/demo-project/src/app.js
@@ -0,0 +1,6 @@
+import { runApp } from 'rax-app';
+import appConfig from './app.json';
+
+import './global.scss';
+
+runApp(appConfig);
diff --git a/packages/code-generator/test-cases/rax-app/demo1/expected/demo-project/src/constants.js b/packages/code-generator/test-cases/rax-app/demo1/expected/demo-project/src/constants.js
new file mode 100644
index 000000000..ea766c9da
--- /dev/null
+++ b/packages/code-generator/test-cases/rax-app/demo1/expected/demo-project/src/constants.js
@@ -0,0 +1,3 @@
+const __$$constants = {};
+
+export default __$$constants;
diff --git a/packages/code-generator/test-cases/rax-app/demo1/expected/demo-project/src/document/index.jsx b/packages/code-generator/test-cases/rax-app/demo1/expected/demo-project/src/document/index.jsx
new file mode 100644
index 000000000..50569a9b6
--- /dev/null
+++ b/packages/code-generator/test-cases/rax-app/demo1/expected/demo-project/src/document/index.jsx
@@ -0,0 +1,25 @@
+import { createElement } from 'rax';
+import { Root, Style, Script } from 'rax-document';
+
+function Document() {
+  return (
+    <html>
+      <head>
+        <meta charset="utf-8" />
+        <meta
+          name="viewport"
+          content="width=device-width,initial-scale=1,maximum-scale=1,minimum-scale=1,user-scalable=no,viewport-fit=cover"
+        />
+        <title>Rax App Demo</title>
+        <Style />
+      </head>
+      <body>
+        {/* root container */}
+        <Root />
+        <Script />
+      </body>
+    </html>
+  );
+}
+
+export default Document;
diff --git a/packages/code-generator/test-cases/rax-app/demo1/expected/demo-project/src/i18n.js b/packages/code-generator/test-cases/rax-app/demo1/expected/demo-project/src/i18n.js
new file mode 100644
index 000000000..8f0de31e0
--- /dev/null
+++ b/packages/code-generator/test-cases/rax-app/demo1/expected/demo-project/src/i18n.js
@@ -0,0 +1,31 @@
+import IntlMessageFormat from 'intl-messageformat';
+
+const i18nConfig = {};
+
+let locale = 'en-US';
+
+const getLocale = () => locale;
+
+const setLocale = (target) => {
+  locale = target;
+};
+
+const i18nFormat = ({ id, defaultMessage }, variables) => {
+  const msg = (i18nConfig && i18nConfig[locale] && i18nConfig[locale][id]) || defaultMessage;
+  if (msg == null) {
+    console.warn('[i18n]: unknown message id: %o (locale=%o)', id, locale);
+    return `${id}`;
+  }
+
+  if (!variables || !variables.length) {
+    return msg;
+  }
+
+  return new IntlMessageFormat(msg, locale).format(variables);
+};
+
+const i18n = (id) => {
+  return i18nFormat({ id });
+};
+
+export { getLocale, setLocale, i18n, i18nFormat };
diff --git a/packages/code-generator/test-cases/rax-app/demo1/expected/demo-project/src/pages/Home/index.jsx b/packages/code-generator/test-cases/rax-app/demo1/expected/demo-project/src/pages/Home/index.jsx
new file mode 100644
index 000000000..cb5a4ddbe
--- /dev/null
+++ b/packages/code-generator/test-cases/rax-app/demo1/expected/demo-project/src/pages/Home/index.jsx
@@ -0,0 +1,157 @@
+// 注意: 出码引擎注入的临时变量默认都以 "__$$" 开头，禁止在搭建的代码中直接访问。
+// 例外：rax 框架的导出名和各种组件名除外。
+import { createElement, Component } from 'rax';
+import { withRouter as __$$withRouter } from 'rax-app';
+
+import Page from 'rax-view';
+
+import Text from 'rax-text';
+
+import { create as __$$createDataSourceEngine } from '@ali/lowcode-datasource-engine/runtime';
+
+import { isMiniApp as __$$isMiniApp } from 'universal-env';
+
+import __$$constants from '../../constants';
+
+import * as __$$i18n from '../../i18n';
+
+import __$$projectUtils from '../../utils';
+
+import './index.css';
+
+class Home$$Page extends Component {
+  _methods = this._defineMethods();
+
+  _context = this._createContext();
+
+  _dataSourceConfig = this._defineDataSourceConfig();
+  _dataSourceEngine = __$$createDataSourceEngine(this._dataSourceConfig, this._context, { runtimeConfig: true });
+
+  _utils = this._defineUtils();
+
+  componentDidMount() {
+    this._dataSourceEngine.reloadDataSource();
+  }
+
+  componentWillUnmount() {}
+
+  render() {
+    const __$$context = this._context;
+    const {
+      state,
+      setState,
+      dataSourceMap,
+      reloadDataSource,
+      utils,
+      constants,
+      i18n,
+      i18nFormat,
+      getLocale,
+      setLocale,
+    } = __$$context;
+
+    return (
+      <Page>
+        <Text>Hello world!</Text>
+      </Page>
+    );
+  }
+
+  _createContext() {
+    const self = this;
+
+    // 保存下最新的状态，这样 setState 可以搞成同步一样的了
+    self._latestState = self.state;
+
+    const context = {
+      get state() {
+        // 这里直接获取最新的 state，从而能避免一些 React/Rax 这样的框架因为异步 setState 而导致的一些问题
+        return self._latestState;
+      },
+      setState(newState) {
+        self._latestState = { ...self._latestState, ...newState };
+        self.setState(newState);
+      },
+      get dataSourceMap() {
+        return self._dataSourceEngine.dataSourceMap || {};
+      },
+      async reloadDataSource() {
+        await self._dataSourceEngine.reloadDataSource();
+      },
+      get utils() {
+        return self._utils;
+      },
+      get page() {
+        return context;
+      },
+      get component() {
+        return context;
+      },
+      get props() {
+        return self.props;
+      },
+      get constants() {
+        return __$$constants;
+      },
+      i18n: __$$i18n.i18n,
+      i18nFormat: __$$i18n.i18nFormat,
+      getLocale: __$$i18n.getLocale,
+      setLocale(locale) {
+        __$$i18n.setLocale(locale);
+        self.forceUpdate();
+      },
+      ...this._methods,
+    };
+
+    return context;
+  }
+
+  _defineDataSourceConfig() {
+    const __$$context = this._context;
+    return { list: [] };
+  }
+
+  _defineUtils() {
+    const utils = {
+      ...__$$projectUtils,
+    };
+
+    Object.entries(utils).forEach(([name, util]) => {
+      if (typeof util === 'function') {
+        utils[name] = util.bind(this._context);
+      }
+    });
+
+    return utils;
+  }
+
+  _defineMethods() {
+    const __$$methods = {};
+
+    // 为所有的方法绑定上下文
+    Object.entries(__$$methods).forEach(([methodName, method]) => {
+      if (typeof method === 'function') {
+        __$$methods[methodName] = (...args) => {
+          return method.apply(this._context, args);
+        };
+      }
+    });
+
+    return __$$methods;
+  }
+}
+
+export default __$$withRouter(Home$$Page);
+
+function __$$eval(expr) {
+  try {
+    return expr();
+  } catch (err) {
+    console.warn('Failed to evaluate: ', expr, err);
+  }
+}
+
+function __$$evalArray(expr) {
+  const res = __$$eval(expr);
+  return Array.isArray(res) ? res : [];
+}
